Description

Currently it's difficult (non-obvious) how to get the centroid of a polygon using the field calculator:

xmin(centroid($geometry))
ymin(centroid($geometry))

As a user I'd expect it to simply be:
$x
By

If it's a polygon, assuming there are no parameters it seems reasonable to me that $x/$y would result in the respective coordinates of the
centroid.

Associated revisions

Revision 55027e54 - 2015-09-18 01:09 AM - Nyall Dawson

Clean up and extend expression geometry functions:

- New expression functions for area(geom), perimeter(geom),
point_n(geom), start_point(geom), end_point(geom), make_point(x,y)
- Add new variant to length() function which takes a geometry object,
allows for length(geom) evaluation.

- Rename x_at, y_at to $x_at, $y_at (alias old names) to reflect that
these only work on current feature geometry

- Add x(geom), y(geom) functions which return x and y coordinate

for point geometries or centroid x/y for non-point geometries

(fix #11008)

History

#1 - 2014-08-05 03:35 AM - Andreas Neumann

You probably meant:

x(centroid($geometry))
y(centroid($geometry))

$x/$y would not work on a polygon, which is the input geometry.
#2 - 2014-08-05 03:49 AM - Jonathan Moules

| get what you're saying but the version you put (using "x" rather than "xmin") is no more obvious than the version that is currently in use because you still
have the whole "centroid(geometry)" part.

$x and Sy are obvious to end users (well as obvious as it can get given the nature of these things). The rest of the stuff should be done automagically
behind the scenes.

| appreciate they don't currently work with the polygon geometry, the notion behind the ticket is that | believe they should work.

Hope that's clearer.

#3 - 2014-08-05 06:22 PM - Antonio Locandro

First of all the current behaviour is a very bad choice, it should have been x(centroid($geometry)),y(centroid($geometry)) from the start anyway. | also thing

$geometry could have been replaced by $geom which is shorter if you have to type a lot

Having said that you could asume $x and $y for a polygon to return the centroid for it

Another option is to have something like

$centroid.x > will return longitude

$centroid.y > will return latitude

$centroid > will return an x,y tuple

As you see | am omiting writing $geometry since it should be implied, like when you calculate $area or $perimeter

It is a design choice but | think it would be nicer if one could ommit writing $geometry when possible

#4 - 2015-09-17 04:09 PM - Nyall Dawson
- Status changed from Open to Closed

Fixed in changeset commit:"55027e545f6265aaeda47dc48923cd5be6ad7d74".
